<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['manage:analyzeResult:add']"
        >选择解析文件</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['manage:analyzeResult:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="analyzeResultList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="源数据文件名称" align="center" prop="sourceName" />
      <el-table-column label="解析后文件名称" align="center" prop="name" />
      <el-table-column label="备注" align="center" prop="remark"/>
      <el-table-column label="解析后结果列表" align="center" />
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改数据解析结果对话框 -->
    <el-dialog :title="title" :visible.sync="open" :close-on-click-modal="false" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="文件名" prop="name">
          <el-select v-model="form.name" placeholder="请选择要解析的数据" style="width:100%">
            <el-option
              v-for="item in sourceDataList"
              :key="item.name"
              :label="item.name"
              :value="item.name">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm" :loading="butLoading">{{butText}}</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAnalyzeResult, getAnalyzeResult, delAnalyzeResult, addAnalyzeResult, updateAnalyzeResult } from "@/api/manage/analyzeResult";
import {
  listDataDown
} from "@/api/manage/dataDown";
export default {
  name: "AnalyzeResult",
  data() {
    return {
      // 按钮加载
      butLoading: false,
      // 按钮显示文本
      butText: "开始解析",
      // 源数据文件列表
      sourceDataList: [],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 数据解析结果表格数据
      analyzeResultList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
         
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    this.getSourceDataList();
  },
  methods: {
    getSourceDataList() {
      // listDataDown(this.queryParams).then(response => {
      //   this.sourceDataList = response.rows;
      // });
      this.sourceDataList = JSON.parse(localStorage.getItem("data-down")) || [];
    },
    /** 查询数据解析结果列表 */
    getList() {
      this.loading = true;
      // listAnalyzeResult(this.queryParams).then(response => {
      //   this.analyzeResultList = response.rows;
      //   this.total = response.total;
      //   this.loading = false;
      // });
      this.analyzeResultList = JSON.parse(localStorage.getItem("data-analyze")) || [];
      this.total = this.dataDownList?.length || 0;
      this.loading = false;
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        name: null,
        remark: null
         
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加数据解析结果";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getAnalyzeResult(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改数据解析结果";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.butLoading = true;
      this.butText = "解析中...";
      setTimeout(() => {
        // 服务获取文件
        let dataObj = {
          name: `解析后固定格式_${new Date().getTime()}.xlsx`,
          sourceName: this.form.name,
          remark: this.form.remark,
        };
        let data = JSON.parse(localStorage.getItem("data-analyze")) || [];
        data.push(dataObj);
        localStorage.setItem("data-analyze", JSON.stringify(data));
        this.getList();
        // 保存指定路径
        this.butLoading = false;
        this.butText = "开始解析";
        this.$modal.msgSuccess("解析成功");
        this.open = false;
      }, 1000);
      // this.$refs["form"].validate(valid => {
      //   if (valid) {
      //     if (this.form.id != null) {
      //       updateAnalyzeResult(this.form).then(response => {
      //         this.$modal.msgSuccess("修改成功");
      //         this.open = false;
      //         this.getList();
      //       });
      //     } else {
      //       addAnalyzeResult(this.form).then(response => {
      //         this.$modal.msgSuccess("新增成功");
      //         this.open = false;
      //         this.getList();
      //       });
      //     }
      //   }
      // });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除数据解析结果编号为"' + ids + '"的数据项？').then(function() {
        return delAnalyzeResult(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('manage/analyzeResult/export', {
        ...this.queryParams
      }, `analyzeResult_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
